<?php
//-------------------------------------------------------------
function debug_message( $subject, $message )
{
//  x    $debug
	global $debug;
	if ($debug) send_message( $subject, $message );
}
//-------------------------------------------------------------
function auth_who ($from_who)
{
//   (   ),
//  ,   true,  - false
//
//   $from_who
// 	From xxxx.ilt.kharkov.ua!user@xxxx.ilt.kharkov.ua Sun Mar 14 20:08:08 2004
//	From: "Ivan Ivanov" <ivanov@ilt.kharkov.ua>
//
// 
// :
//**************************************************************
//      
//    antispam-uucp, 
//       aliases  
//        uuname 
//**************************************************************
global $pa;
global $lan;
global $debug;
global $aliases;
global $ilt_uuname;
global $email_request;
global $info;
global $uuname;
global $to_user_address;
$sum = $res = '';
$error = '';
$uuname = '';
$user = '';
$lan = false;

if (preg_match("/(From|Return-Path):?.*<(.*).ilt.kharkov.ua!(.*@.*.ilt.kharkov.ua)>.*/",$from_who, $res)) {

	// UUCP style addressing, for example 
	// 	From xxxx.ilt.kharkov.ua!user@xxxx.ilt.kharkov.ua Sun Mar 14 20:08:08 2004
	//	in this example $res[2]=xxxx, res[3]=user@xxxx.ilt.kharkov.ua
	if ($debug) print_r($res);
	$uuname = $res[2];
	$to_user_address = $res[3];
	if ($debug) send_message("1.1", "UUCP style addressing, uuname=$uuname/ to_user_address=$to_user_address/"); 
}
elseif (preg_match("/(From|Return-Path):?\s+(.*).ilt.kharkov.ua!(.*@.*.ilt.kharkov.ua).*/",$from_who, $res)) {
	// UUCP style addressing, for example 
	// 	From xxxx.ilt.kharkov.ua!user@xxxx.ilt.kharkov.ua Sun Mar 14 20:08:08 2004
	//	in this example $res[2]=xxxx, res[3]=user@xxxx.ilt.kharkov.ua
	if ($debug) print_r($res);
	$uuname = $res[2];
	$to_user_address = $res[3];
	if ($debug) send_message("1.2", "UUCP style addressing, uuname=$uuname/ to_user_address=$to_user_address/"); 
} 
elseif (preg_match("/(From|Return-Path):?.*<(.*@ilt.kharkov.ua)>.*/",$from_who, $res)) {
	// General case, for example
	//	From: "Ivan Ivanov" <ivanov@ilt.kharkov.ua>
	// 	in this example $res[2]="ivanov@ilt.kharkov.ua"
	$to_user_address = $res[2];
	if ($debug) print_r($res);	
	$lan = true;
	debug_message("2", "LAN addressing, case 1, addr=$res[2], lan=$lan");
	}
elseif (preg_match("/(From|Return-Path):?\s+(.*@ilt.kharkov.ua).*/",$from_who, $res)) {
	// General case, for example
	//	From ivanov@ilt.kharkov.ua
	// 	in this example $res[2]="ivanov@ilt.kharkov.ua"
	$to_user_address = $res[2];
	
	$lan = true;
	debug_message("3", "LAN addressing,case 2, addr=$res[2], lan=$lan");
}
else  {
	debug_message ("X", "Error: request from invalid address $from_who" );
	return false;
}

//     $user  $domen
list ($user, $domen) = split("@", $to_user_address);

//       
$user = strtolower($user);
$domen = strtolower($domen);

debug_message("4","to_user_address=$to_user_address/ user=$user/ domen=$domen/ uuname=$uuname");
if ($debug) send_message("4","to_user_address=$to_user_address/ user=$user/ domen=$domen/ uuname=$uuname");

//        ilt.kharkov.ua 
//    $uuname,    

if ($lan) { 
	//      ($uuname ='')
	//   uuname  $user  /etc/mail/aliases,
	//     
	//       aliases
	//     $aliases:
	// 	user: user@lan.ilt.kharkov.ua
	//	user: user$uuname.ilt.kharkov.ua
	//	user: user@lan.ilt.kharkov.ua,user$uuname.ilt.kharkov.ua	

	$user_aliases = preg_grep("/$user/", $aliases); 
	
	if ($debug) {
		echo "User aliases:\n";
		print_r($user_aliases);
	}
	
	//    aliases   ,  
	//   ,  ...  
	if (count($user_aliases) == 0) {
		send_message("666", "Unauthorized user=$user");
		return false;
	}
	
	//    grep , 
	//   $user
	foreach ($user_aliases as $i => $value) {

		// - - (#   ) - 
		if ((!(($pos=strpos($value,"#")) === false))&&($pos==0)) continue;		
		
		//     $user: - 
		if ((($pos=strpos($value, "$user:")) === false)||($pos != 0)) continue;
		
		// ,  , ,    uuname
		//      aliases,
		$components = preg_split("/[:\s,]/", $value);
	
		//     
		//	Array
		//(
		//    [0] => ivanov
		//    [1] => 
		//    ......
		//    [6] => ivanov@xxxx.ilt.kharkov.ua
		//    [7] => ivanov@lan.ilt.kharkov.ua
		//)
		
	
		debug_message("5", "size components=".count($components));
		// print_r($components);
	
		//       
		// lan.ilt.kharkov.ua ( ),  
		// <uuname>.ilt.kharkov.ua (    uuname)
		$uuname = 'invalid';
		debug_message("5.1", "uuname=$uuname\n");

		foreach ($components as $i => $value) {
			if (($value == '') || (preg_match("/.*@lan.ilt.kharkov.ua/",$value, $res))) {
				//  ,      uuname
				continue;
			} 
			elseif (preg_match("/.*@(.*).ilt.kharkov.ua/",$value, $res)) {
				$uuname = $res[1]; //   uuname
				break;
			}
		}
	}
} // end if ($lan)

// ---------------------- ADMIN CASE ---------------------------
//
//    -  
//    ais ($pa=true),    ais2 ($pa=false)

	if (($lan)&&($user == "admin")) {

	//        Subject,	
	//        uuname,
	scan_letter( $email_request );
	if ($debug) {
		echo "info=\n";
		print_r($info);
	}

	if ($pa) {
		//   ais -   Subject  -
		//   yyy -  uuname
		
		list ($sub, $uuname) = split(":", $info['Subject']);
		$uuname = trim($uuname);
		if ($uuname == '') $uuname = 'yyy';
	}                                                      
	else {	
		//   ais2,  
		// Subject: antispam-info-(<uuname>)
		$r =  $info['Subject'];
		if (preg_match("/.*antispam-info-\((.*)\).*/", $r, $res)) {
			$uuname = $res[1];
			if ($debug) echo "Ais2-uuname=$uuname/\n";
		}
	}

	if ($debug) echo "uuname=$uuname/ sub=$sub/\n";

} // end admin case

debug_message("9", "uuname=$uuname/ user=$user/");

//   $uuname,    ,
//   -   aliases.
//   $uuname
$res = preg_grep("/$uuname/", $ilt_uuname);

debug_message("10", "res=$res/ uuname=$uuname ilt_uuname=$ilt_uuname");
if ($debug) print_r($res);

//   (  ,    )
foreach ($res as $value) { 
	$tname = trim($value); // (trim        
}	

if ( empty($res) || $tname !== $uuname ) {
	debug_message("12", "It is invalid uuname=$uuname/ lan=$lan");
	return false;
}

debug_message("13", "It is valid uuname=$uuname/ lan=$lan");
return true;

} // end auth_who

//-----------------------------------------------------------
function subj_from_decode( $subj_from )
{
// decode fields Subject and  From, for example $subj_from:
// 'Subject: =?koi8-r?Q?=F4=EF=F020=20=CB=CF=CD=D0=D8=C0=D4=C5=D2=CE=D9=C8=20=?koi8-r?Q?=F4=EF=F020=20=CB=CF=CD=D0=D8=C0=D4=C5=D2=CE=D9=C8=20$
// 'From: "=?windows-1251?B?SWdvcg==?=" <Vitaliy@mail.od.ua>'

        if (preg_match("/(?i)(.*)=\?(koi8-r|windows-1251)\?(.)\?(.*)\?=(.*)/", $subj_from, $res)) {

                // $res[0] = all subj_from
                // $res[1] = (Subject:|From:)
                // $res[2] = (koi8-r|Windows-1251)
                // $res[3] = (Q|B)  Q - quoted printable, B - base64
                // $res[4] = <encoded text>
                // $res[5] = <address in From field>
                // print_r($res);

                if ($res[3] == 'Q') { // quoted printable case
                        $retval = quoted_printable_decode( $res[4] );
                        if (stristr($res[2],'windows-1251')) {
                                //  w - windows-1251 to  k - koi8-r
                                $retval = convert_cyr_string( $retval, 'w', 'k' );
                        }
                }
                elseif ($res[3] == 'B') { // base64 case
                        $retval = base64_decode( $res[4] );
                        if (stristr($res[2],'windows-1251')) {
                                //  w - windows-1251 to  k - koi8-r
                                $retval = convert_cyr_string( $retval, 'w', 'k' );
                        }
                }
                return $res[1].$retval.$res[5]."\n";
        }
        else {
                return $subj_from;  // without changes
        }
}

?>
